<?php
/*
 * Default values
 */

// The next few should be self explanatory...
$SHOW_BUFFS = TRUE;
$SHOW_PROFESSIONS = TRUE;
$SHOW_SET_DATA = TRUE;

// When enabled, WAT will use some Javascript magic to set item
// quality and character class colors.
$AUTOCOLOR_ITEM_QUALITY = TRUE;
$AUTOCOLOR_CHAR_CLASS = TRUE;

// When enabled, prepends race & class icons before the char's armory
// link, and the item's (small) icon before item links.
$AUTO_RACE_ICON = FALSE;
$AUTO_CLASS_ICON = FALSE;
$AUTO_ITEM_ICON = FALSE;

// The base URL of the armory: www for US, eu for europe, and so on.
$ARMORY_URL = "http://eu.wowarmory.com/";

// Language of the tooltips: en for english, fr for french, etc
$ARMORY_LANGUAGE = "en";

// The template to use.
// As of this writing, only the "default" template exists.
$TEMPLATE = 'default';

/*
 * Caching
 *
 * Do not touch these, unless you want to set up caching, and know
 * what you're doing!
 */

// Host the MySQL server is on, usually 'localhost'
$CACHE_HOST = '';
// MySQL database to connect to
$CACHE_DB = '';
// With the provded user & password
$CACHE_USER = '';
$CACHE_PASSWORD = '';
// The table where cached items are to be stored.
// NOTE: It _must_ exist before enabling caching!
$CACHE_TABLE = '';

/*
 * Armory data proxy cache.
 * This uses the same db, user & password as normal caching, but a
 * different table.
 *
 * Set a table to enable this feature.
 */
$PROXY_TABLE = '';

/*
 * Cache aging configuration
 */
$CACHE_AGE = array (
	'tooltip' => array (
		'char' => 60 * 60 * 6,		// 6 hours
		'char_class' => 60*60*24*30,	// 30 days
		'item' => 60*60*24*30,		// 30 days
		'item_quality' => 60*60*24*30,	// 30 days
		'item_icon' => 60*60*24*30,	// 30 days
		'icon' => 60*60*24*30,		// 30 days
		'guild' => 60 * 60 * 6,		// 6 hours
	),
	'proxy' => 60 * 60 * 24 * 30,		// 30 days
);
?>
