<?php

class WAT_Guild_ToolTip
{
	private $faction = array (
		0 => 'Alliance',
		1 => 'Horde',
	);

	protected $public_data = array ();

	protected $guild;
	protected $realm;
	
	protected $armory;
	protected $armory_data;
	protected $url_base;

	public $error_message;

	public function __construct ($guild, $realm, $armory, $url_base = NULL)
	{
		$this->guild = $guild;
		$this->realm = $realm;
		$this->armory = $armory;
		if ($url_base) {
			$this->url_base = $url_base;
		} else {
			$this->url_base = $this->armory->armory;
		}

		$this->error_message = null;

		$this->generate ();
	}

	private function grab_armory ()
	{
		$guild = $this->armory->guildFetch ($this->guild, $this->realm);

		$item = $item['itemtooltips']['itemtooltip'];

		if (count ($guild['guildkey']) == 0) {
			$this->error_message = 'Error connecting to the armory, or guild not found.';
			return;
		}

		$this->armory_data = $guild;
	}

	private function generate ()
	{
		$this->grab_armory ();

		$this->public_data = array (
			'info' => array (
				'faction' => $this->faction[$this->armory_data['guildkey']['factionid']],
				'faction_id' => $this->armory_data['guildkey']['factionid'],
				'name' => $this->armory_data['guildkey']['name'],
				'realm' => $this->armory_data['guildkey']['realm'],
				'member_count' => $this->armory_data['guildheader']['members']['value'],
				'battlegroup' => $this->armory_data['guildheader']['battlegroup']['value'],
				'emblem' => $this->armory_data['guildheader']['emblem'],
			),
			'url_base' => $this->url_base,
			'members' => $this->armory_data['guildinfo']['guild'],
		);
	}

	public function __get ($index)
	{
		$r = $this->public_data[$index];
		return $r;
	}
}
?>
