<html>
<head>
<title>WAT Installation Verification</title>
<style type="text/css">
	 body { background: black; color: white; }
	 .ok { color: lime; }
	 .fail { color: red; }
	 .warn { color: yellow; }
 </style>
</head>
<body>

<?php
@error_reporting(E_ALL ^ E_NOTICE);

function test_result ($r, $msg) {
	print "<span class='$r'>" . $msg . "</span>\n";
}
?>

<table cellpadding="1px" cellspacing="10px">

<!-- Check PHP version, >= 5.1.0 required -->
<tr><td>PHP Version (>= 5.1.0)</td><td><?php
if (version_compare (PHP_VERSION, '5.1.0') === 1) {
	test_result ('ok', PHP_VERSION);
} else {
	test_result ('fail', PHP_VERSION);
}
?></td></tr>

<!-- Check curl -->
<tr><td>Curl</td><td><?php
if (array_search ('curl', get_loaded_extensions ()) !== FALSE) {
	$cv = curl_version ();
	test_result ('ok', $cv['version']);
} else {
	test_result ('warn', "No cURL module installed (optional, url_fopen works too)");
}
?></td></tr>

<!-- Check url_fopen -->
<tr><td>url_fopen</td><td><?php
if (ini_get ('allow_url_fopen')) {
	test_result ('ok', 'allowed');
} else {
	test_result ('warn', "url_fopen disabled (optional, cURL works too)");
}
?></td></tr>

<!-- Check included files -->
<tr><td>includes/defaults.php</td><td><?php
if ((include_once ('../includes/defaults.php'))) {
	test_result ('ok', 'present');
} else {
	test_result ('fail', 'missing');
}
?></td></tr>

<tr><td>includes/phpArmory.class.php</td><td><?php
if ((include_once ('../includes/phpArmory.class.php'))) {
	test_result ('ok', 'present');
} else {
	test_result ('fail', 'missing');
}
?></td></tr>

<tr><td>includes/wat_char_tooltip.class.php</td><td><?php
if ((include_once ('../includes/wat_char_tooltip.class.php'))) {
	test_result ('ok', 'present');
} else {
	test_result ('fail', 'missing');
}
?></td></tr>

<tr><td>includes/wat_item_tooltip.class.php</td><td><?php
if ((include_once ('../includes/wat_item_tooltip.class.php'))) {
	test_result ('ok', 'present');
} else {
	test_result ('fail', 'missing');
}
?></td></tr>

<!-- Test functionality -->
<tr><td>$armory object creation</td><td><?php
$armory = new phpArmory ($ARMORY_URL);

if ($armory) {
	test_result ('ok', 'ok');
} else {
	test_result ('fail', 'failed');
}
?></td></tr>

<tr><td>Char tooltip lookup</td><td><?php
if ($ARMORY_URL == "http://www.wowarmory.com/") {
	$char = new WAT_Char_ToolTip ('Emmortal', "Mal'Ganis", $armory, NULL);
} else {
	$char = new WAT_Char_ToolTip ('Notalda', 'Sporeggar', $armory, NULL);
}

if ($char->error_message != null) {
	test_result ('warn', $char->error_message);
} else {
	test_result ('ok', 'ok');
}
?></td></tr>

<tr><td>Item tooltip lookup</td><td><?php
$item = new Wat_Item_ToolTip ('Tuxedo Jacket', $armory, NULL);
if ($item->error_message != null) {
	test_result ('fail', $item->error_message);
} else {
	test_result ('ok', 'ok');
}
?></td></tr>

<tr><td>Item tooltip lookup (in french)</td><td><?php
$armory->setlang ('fr');
$item = new Wat_Item_ToolTip ('Bague en néangon fondu', $armory, NULL);
if ($item->error_message != null) {
	test_result ('fail', $item->error_message);
} else {
	test_result ('ok', 'ok');
}
?></td></tr>

</table>
</body>
</html>
