<?php
$el = @error_reporting (0);

require_once ('includes/defaults.php');
if (file_exists ('config.php')) {
	include_once ('config.php');
}

require_once ('includes/phpArmory.class.php');
require_once ('includes/wat_get_url.php');

require_once ('includes/wat_char_tooltip.class.php');
require_once ('includes/wat_item_tooltip.class.php');
require_once ('includes/wat_guild_tooltip.class.php');
require_once ('includes/wat_cache.class.php');

@error_reporting (E_ALL ^ (E_WARNING | E_NOTICE));

/*
 * Variables
 */
$cache_ok = true;
$self_dir = dirname ($_SERVER['PHP_SELF']) . '/';

$pitem = urldecode ($_GET['item']);
$pchar = urldecode ($_GET['char']);
$prealm = urldecode ($_GET['realm']);
$pentry = urldecode ($_GET['e']);
$pguild = urldecode ($_GET['guild']);
$picon = urldecode ($_GET['icon']);
$pprop = urldecode ($_GET['prop']);

$pentry = str_replace ("\'", "'", $pentry);
$prealm = str_replace ("\'", "'", $prealm);
$pitem = str_replace ("\'", "'", $pitem);
$pguild = str_replace ("\'", "'", $pguild);

if ($_GET['nocache']) {
	$cache_ok = false;
}

if ($PROXY_TABLE) {
	$proxy = $self_dir . 'wat.php?e=';
} else {
	$proxy = NULL;
}

/*
 * Determine what kind of tooltip we shall return...
 */
$mode = "error"; // By default, an error. Heh-heh.

if ($pentry) {
	$mode = "proxy";
	$cache_id = $pentry;
} else if ($prealm) {
	if ($pchar) {
		if ($picon) {
			switch ($picon) {
			case "class":
			case "race":
				$mode = "icon";
				$cache_id = 'icon.' . strtolower ($picon) . '.' . strtolower ($pchar) . '.' . strtolower ($prealm);
			}
		} else if ($pprop) {
			switch ($pprop) {
			case "class":
				$mode = "char_class";
				$cache_id = 'char.class.' . strtolower ($pchar) . '.' . strtolower ($prealm);
				break;
			}
		} else {
			$mode = "char";
			$cache_id = 'char.' . strtolower ($pchar) . '.' . strtolower ($prealm);
		}
	} else if ($pguild) {
		$mode = "guild";
		$cache_id = 'guild.' . strtolower ($pguild) . '.' . strtolower ($prealm);
	}
} else if ($pitem) {
	if ($pprop) {
		switch ($pprop) {
		case "quality":
		case "icon":
			$mode = 'item_' . $pprop;
			$cache_id = 'item.' .$pprop . '.' . strtolower ($pitem);
			break;
		}
	} else {
		$mode = "item";
		$cache_id = 'item.' . strtolower ($pitem);
	}
}


/*
 * Functions
 */

function get_char ($pchar, $prealm, $armory, $proxy)
{
	global $TEMPLATE, $SHOW_BUFFS, $SHOW_PROFESSIONS;

	$char = new WAT_Char_ToolTip ($pchar, $prealm, $armory, $proxy);

	if ($char->error_message != null) {
		$wat_error_message = $char->error_message;
		require_once ('template/'. $TEMPLATE . '/error.php');
		return false;
	}

	require_once ('template/' . $TEMPLATE . '/char.php');
	return true;
}

function get_char_class ($pchar, $prealm, $armory, $proxy)
{
	$char = new WAT_Char_ToolTip ($pchar, $prealm, $armory, $proxy);
	if ($char->error_message != null) {
		return false;
	}
	
	print "wat_tt_class_" . preg_replace('/\s/', '', (strtolower ($char->char['class'])));
	return true;
}

function get_item ($pitem, $armory, $proxy)
{
	global $TEMPLATE, $SHOW_SET_DATA;

	$item = new WAT_Item_ToolTip ($pitem, $armory, $proxy);

	if ($item->error_message != null) {
		$wat_error_message = $item->error_message;
		require_once ('template/' . $TEMPLATE . '/error.php');
		return false;
	}

	require_once ('template/' . $TEMPLATE . '/item.php');
	return true;
}

function get_item_quality ($pitem, $armory, $proxy)
{
	$item = new WAT_Item_ToolTip ($pitem, $armory, $proxy);

	if ($item->error_message != null) {
		return false;
	}

	print "wat_item_q_" . $item->item['quality'];
	return true;
}

function get_item_icon ($pitem, $armory, $proxy)
{
	$item = new WAT_Item_ToolTip ($pitem, $armory, $proxy);

	if ($item->error_message != null || !$item->item['icon']) {
		print 'template/' . $TEMPLATE . '/images/error.png';
		return false;
	}

	print str_replace ('/43x43/', '/21x21/', $item->item['icon']);
	return true;
}

function get_guild ($pguild, $prealm, $armory, $proxy)
{
	global $TEMPLATE;

	$guild = new WAT_Guild_ToolTip ($pguild, $prealm, $armory, $proxy);

	if ($guild->error_message != null) {
		$wat_error_message = $guild->error_message;
		require_once ('template/' . $TEMPLATE . '/error.php');
		return false;
	}

	require_once ('template/' . $TEMPLATE . '/guild.php');
	return true;
}

function get_icon ($picon, $pchar, $prealm, $armory, $proxy)
{
	global $TEMPLATE, $cache_ok;

	$cd = $armory->characterFetch ($pchar, $prealm);

	if (count ($cd) == 0 || $cd['errcode'] == 'noCharacter' || !$cd['characterinfo']['character']['classid']) {
		print 'template/' . $TEMPLATE . '/images/error.png';
		return false;
	}

	$url_base = ($proxy && $cache_ok) ? $proxy : $armory->armory;
	switch ($picon) {
	case "class":
		print $url_base . 'images/icons/class/' . $cd['characterinfo']['character']['classid'] . '.gif';
		break;
	case "race":
		print $url_base . 'images/icons/race/' . $cd['characterinfo']['character']['raceid'] . '-' .
			$cd['characterinfo']['character']['genderid'] . '.gif';
		break;
	}
	
	return true;
}

function get_mime_type ($filename)
{
	preg_match ("|\.([a-z0-9]{2,4})$|i", $filename, $fileSuffix);

        switch (strtolower ($fileSuffix[1])) {
	case "jpg" :
	case "jpeg" :
	case "jpe" :
                return "image/jpg";

	case "png" :
	case "gif" :
                return "image/" . strtolower ($fileSuffix[1]);

	default:
		return "application/octet-stream";
	}
}

function fetch_data ($mode, $params)
{
	global $ARMORY_URL, $ARMORY_LANGUAGE, $proxy;

	switch ($mode) {
	case "proxy":
		$d = wat_get_url ($ARMORY_URL . $params[0], $ARMORY_LANGUAGE);
		$ct = get_mime_type ($params[0]);
		$r = true;
		break;
	case "char":
	case "char_class":
	case "item":
	case "item_quality":
	case "item_icon":
	case "icon":
	case "guild":
		$armory = new phpArmory ($ARMORY_URL);
		$armory->setlang ($ARMORY_LANGUAGE);

		ob_start ();
		$r = call_user_func_array ('get_' .$mode, array_merge ($params, array ($armory, $proxy)));
		$d = ob_get_contents ();
		$ct = 'text/html';
		ob_end_clean ();
		break;
	}

	return array ('status' => $r, 'data' => $d, 'content-type' => $ct);
}

/*
 * Cache setup, and serving from cache, if needed.
 */
if ($CACHE_TABLE && $cache_ok) {
	switch ($mode) {
	case "proxy":
		$cache = new WAT_Cache ('mysql:dbname=' . $CACHE_DB . ';host=' . $CACHE_HOST, $CACHE_USER,
					$CACHE_PASSWORD, $PROXY_TABLE, $CACHE_AGE['proxy'], 'data');
		break;
	case "char":
	case "char_class":
	case "item":
	case "item_quality":
	case "item_icon":
	case 'icon':
	case "guild":
		$cache = new WAT_Cache ('mysql:dbname=' . $CACHE_DB . ';host=' . $CACHE_HOST, $CACHE_USER,
					$CACHE_PASSWORD, $CACHE_TABLE, $CACHE_AGE['tooltip'][$mode], 'tooltip');
		break;
	}

	if ($cache[$cache_id]) {
		if ($mode == "proxy") {
			header ('Content-Type: ' . get_mime_type ($pentry));
		}
		if ($mode != "icon" && $mode != 'item_icon') {
			print $cache[$cache_id];
		} else {
			header ('Location: ' . $cache[$cache_id]);
		}
		
		return;
	}
}

/*
 * Direct fetch
 */
switch ($mode) {
case "char":
case "char_class":
	$r = fetch_data ($mode, array ($pchar, $prealm));
	break;
case "guild":
	$r = fetch_data ($mode, array ($pguild, $prealm));
	break;
case "item":
case "item_quality":
case "item_icon":
	$r = fetch_data ($mode, array ($pitem));
	break;
case "icon":
	$r = fetch_data ($mode, array ($picon, $pchar, $prealm));
	break;
case "proxy":
	$r = fetch_data ($mode, array ($pentry));
	break;
case "error":
	$wat_error_message = 'Unexpected error, consult the logs';
	require_once ('template/'. $TEMPLATE . '/error.php');
	return;
}

if (strlen ($r['data']) == 0) {
	switch ($mode) {
	case "item_icon":
	case "proxy":
		header ('Location: template/' . $TEMPLATE . '/images/error.png');
		return;
	}
	
	$wat_error_message = "Error connecting to the armory";
	require_once ('template/'. $TEMPLATE . '/error.php');
	return;
}

if ($r['status'] && $CACHE_TABLE && $cache_ok && strlen ($r['data']) > 0) {
	$cache[$cache_id] = $r['data'];
}

if ($mode != "icon" && $mode != 'item_icon') {
	header ('Content-Type: ' . $r['content-type']);
	print $r['data'];
} else {
	header ('Location: ' . $r['data']);
}

?>
